<frontpage-quotes>

    <div class="header__instruments">

        <div each={quote, i in lp_quotes().slice(0,1)} data-quote={i} class="instrument__item">
            <i if={quote.db==1} class="bid__arrow bid__arrow-up"></i>
            <i if={quote.db==-1} class="bid__arrow bid__arrow-down"></i>
            <div class="item__name">{quote.name}</div>
            <div class="item__value">
                <raw content="{quote.bid}"></raw>
            </div>
        </div>

        <div each={quote, i in lp_quotes().slice(1,2)} data-quote={i} class="instrument__item">
            <i if={quote.db==1} class="bid__arrow bid__arrow-up"></i>
            <i if={quote.db==-1} class="bid__arrow bid__arrow-down"></i>
            <div class="item__name">{quote.name}</div>
            <div class="item__value">
                <raw content="{quote.bid}"></raw>
            </div>
        </div>

        <div each={quote, i in lp_quotes().slice(2,3)} data-quote={i} class="instrument__item">
            <i if={quote.db==1} class="bid__arrow bid__arrow-up"></i>
            <i if={quote.db==-1} class="bid__arrow bid__arrow-down"></i>
            <div class="item__name">{quote.name}</div>
            <div class="item__value">
                <raw content="{quote.bid}"></raw>
            </div>
        </div>

        <div each={quote, i in lp_quotes().slice(3,4)} data-quote={i} class="instrument__item">
            <i if={quote.db==1} class="bid__arrow bid__arrow-up"></i>
            <i if={quote.db==-1} class="bid__arrow bid__arrow-down"></i>
            <div class="item__name">{quote.name}</div>
            <div class="item__value">
                <raw content="{quote.bid}"></raw>
            </div>
        </div>

    </div>

    <script>

        lp_quotes() {
            const quotes_initial_arr = Array.from(this.quotes_map.values());
            const quotes_render_list = ['EURUSD', 'BRENT', 'XAUUSD', 'BTCUSD']
            let quotes_output_arr = [];

            if (quotes_initial_arr.length > 0) {
                for (let i = 0; i < quotes_render_list.length; i++) {
                    quotes_output_arr.push(quotes_initial_arr.find(element => element.name === quotes_render_list[i]));
                }

                // Remove all undefined elements if they exist
                quotes_output_arr = quotes_output_arr.filter(function (element) {
                   return element !== undefined;
               });
            }

            return quotes_output_arr;
        }

        updateQuotesFromWs(event) {
            var quotes = JSON.parse(event.data);

            this.quotes_map.forEach(function(value, key, map) {
                value.da = 0;
                value.db = 0;
            });

            for (var i = quotes.length - 1; i >= 0; i--) {
                // Remove extra 'b' from names.
                var last_letter = quotes[i].name.substr(-1);
                if (last_letter === 'b') {
                    quotes[i].name = quotes[i].name.substr(0, quotes[i].name.length - 1);
                };

                // Force proper ask and bid decimal places.
                var digits = quotes[i].digits;
                quotes[i].ask = quotes[i].ask.toFixed(digits);
                quotes[i].bid = quotes[i].bid.toFixed(digits);

                if (digits === 3 || digits === 5) {
                    quotes[i].ask = customPipette(quotes[i].ask);
                    quotes[i].bid = customPipette(quotes[i].bid);
                }

                this.quotes_map.set(quotes[i].name, quotes[i]);
            }
            this.update();
        }

        quotes() {
            return Array
                .from(this.quotes_map.values()).slice(0, 15);
        };

        this.quotes_map = new Map();
        this.socket = new ReconnectingWebSocket("wss://wse.du3b.com/wss/quotes_all");
        this.socket.onmessage = this.updateQuotesFromWs;

        // Кастомная пипетка.
        function customPipette(quote) {
            var customHtml = '';
            var digitBeforePoint = quote.split('.')[0];
            var digitAfterPoint = quote.split('.')[1];
            var digitAfterPointArray = digitAfterPoint.split('');

            var quoteWithoutPipette = digitAfterPoint.substr(0, digitAfterPointArray.length - 1);
            var quotePipette = digitAfterPointArray[digitAfterPointArray.length - 1];
            customHtml = digitBeforePoint + '.' + quoteWithoutPipette + '<span class="quote-pipette">' + quotePipette + '</span>';
            return customHtml;
        }

        riot.tag('raw', '<span></span>', function (opts) {
            this.updateContent = function () {
                this.root.innerHTML = opts.content;
            };

            this.on('update', function () {
                this.updateContent();
            });

            this.updateContent();
        });

    </script>

</frontpage-quotes>
